unit UnitReal;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  Data.Bind.EngExt, Fmx.Bind.DBEngExt, FMX.ListView.Types,
  FMX.ListView.Appearances, FMX.ListView.Adapters.Base, System.Rtti,
  System.Bindings.Outputs, Fmx.Bind.Editors, Data.Bind.Components, FMX.ListView,
  Data.DB, Data.Bind.DBScope, Datasnap.DBClient, System.ImageList, FMX.ImgList,
  FMX.StdCtrls, FMX.Controls.Presentation, FMX.Edit, FMX.TabControl;

type
  TForm15 = class(TForm)
    Orders: TClientDataSet;
    BindSourceDB1: TBindSourceDB;
    BindingsList1: TBindingsList;
    Customers: TClientDataSet;
    OrdersOrderNo: TFloatField;
    OrdersCustNo: TFloatField;
    OrdersSaleDate: TDateTimeField;
    OrdersAmountPaid: TCurrencyField;
    OrdersItemsTotal: TCurrencyField;
    CustomersCustNo: TFloatField;
    CustomersCompany: TStringField;
    ListView1: TListView;
    LinkListControlToField1: TLinkListControlToField;
    OrdersSociete: TStringField;
    StyleBook1: TStyleBook;
    StyleBook2: TStyleBook;
    TabControl1: TTabControl;
    TabItem1: TTabItem;
    TabItem2: TTabItem;
    Edit1: TEdit;
    Apply: TButton;
    Cancel: TButton;
    LinkControlToField1: TLinkControlToField;
    LabelOrderNo: TLabel;
    Labeltotal: TLabel;
    LinkPropertyToFieldText: TLinkPropertyToField;
    LinkPropertyToFieldText2: TLinkPropertyToField;
    procedure LinkListControlToField1FilledListItem(Sender: TObject;
      const AEditor: IBindListEditorItem);
    procedure LinkListControlToField1FilledList(Sender: TObject);
    procedure LinkListControlToField1FillingListItem(Sender: TObject;
      const AEditor: IBindListEditorItem);
    procedure UseOnFillListItemSwitch(Sender: TObject);
    procedure ApplyClick(Sender: TObject);
    procedure CancelClick(Sender: TObject);
    procedure ListView1ItemClick(const Sender: TObject;
      const AItem: TListViewItem);
  private
    { Dclarations prives }
    Cumul : Currency;   // cumul par groupe
    Customer : String; // valeur du groupe (premire lettre de la couleur)
    idCust : Extended;
  public
    { Dclarations publiques }
  end;

var
  Form15: TForm15;

implementation

{$R *.fmx}

procedure TForm15.ApplyClick(Sender: TObject);
begin
LinkListControlToField1.Active:=False;
if Orders.State in [dsEdit] then Orders.Post;
LinkListControlToField1.Active:=True;
TabControl1.Previous();
end;

procedure TForm15.CancelClick(Sender: TObject);
begin
if Orders.State in [dsEdit] then Orders.Cancel;
TabControl1.Previous();
end;

procedure TForm15.LinkListControlToField1FilledList(Sender: TObject);
var Pied : TListViewItem;
    texte : String;
    Li : integer;
begin
     // Dplacement des Pieds d'une ligne vers le haut
 {    for Li := 1 to Pred(ListView1.ItemCount) do
     begin
       if ListView1.Items[Li].Purpose=TListItemPurpose.Footer then
         begin
           // rcupre le texte du pied
           Pied:=ListView1.Items[Li];
           Texte:=Pied.Text;
           // Supprime le pied cr (pas d'autre solution ?)
           ListView1.Items.Delete(Li);
           // Insre le nouveau pied
           with ListView1.Items.Insert(Li-1) do
             begin
               Text := Texte;
               Purpose := TListItemPurpose.Footer;
             end;
         end;
     end; }
  // Ajout de la dernire totalisation (=fin de fichier)
  with ListView1.Items.Add do
    begin
      Text := Format('Total %s %3.2f',[Customer,Cumul]);
      Purpose := TListItemPurpose.Footer;
    end;
end;

procedure TForm15.LinkListControlToField1FilledListItem(Sender: TObject;
  const AEditor: IBindListEditorItem);
// le remplissage d'un item est fini
var AnItem : TListViewItem;
    AListItemBitmap : TListItemImage;
    AListItemTextFixe : TListItemText;
    AColor : TAlphaColor;
begin
AnItem:=AEditor.CurrentObject as TListViewItem;
if (AnItem.Purpose=TListItemPurpose.Header) then
 begin
  // Ajout du Pied de Groupe si ce n'est pas le premier groupe
  if (AnItem.Index>1)  then
   begin
     with ListView1.Items.Add do
       begin
         // cet item n'a plus besoin d'tre dplac vers le haut
          Text := AnItem.text;
          Purpose := TListItemPurpose.Header;
          StyleName:='MyListFooter';
          ApplyStyleLookup;
     end;
     AnItem.Text:=Format('Total %s %3.2f',[Customer,Cumul]);
     AnItem.Purpose:=TListItemPurpose.Footer;
     if cumul>100000 then
       begin
         AnItem.Bitmap:=TBitmap.Create(40,40);
         AnItem.Bitmap.Clear(TalphaColorRec.Crimson);
       end;
   end;
  idCust:=OrdersCustNo.Value;
  Customer:=OrdersSociete.asString;
  Cumul:=0;
 end
 else begin
   // Ajout des libells fixes
   AListItemTextFixe:=AnItem.Objects.FindObjectT<TListItemText>('Text6');
   if Assigned(AListItemTextFixe) then AListItemTextFixe.Text:='Montant Total';
   AListItemTextFixe:=AnItem.Objects.FindObjectT<TListItemText>('Text7');
   if Assigned(AListItemTextFixe) then AListItemTextFixe.Text:='Pay';
   // Gestion de la couleur ---------------------------------------------
   AListItemBitmap:=AnItem.Objects.FindObjectT<TListItemImage>('Image4');
   if assigned(AListItemBitmap) then
   begin
    AListItemBitmap.Bitmap:=TBitmap.Create(40,40);
    if OrdersAmountPaid.AsCurrency<OrdersItemsTotal.asCurrency then
       AColor:=TAlphacolorRec.Crimson
    else
      AColor:=TAlphaColorRec.Null;
    AListItemBitmap.Bitmap.Clear(AColor);
   end;
   // ----------------------------------------------------------
   // Cumul par client  (pay)
    Cumul:=Cumul+Orders.FieldByName('AmountPaid').AsCurrency;
 end;
end;

procedure TForm15.LinkListControlToField1FillingListItem(Sender: TObject;
  const AEditor: IBindListEditorItem);
begin
//
end;

procedure TForm15.ListView1ItemClick(const Sender: TObject;
  const AItem: TListViewItem);
begin
TabControl1.Next();
end;

procedure TForm15.UseOnFillListItemSwitch(Sender: TObject);
begin
Orders.Active:=False;
Orders.Active:=True;
end;

end.
